stages:
  - build
  - test

include:
  - template: "Jobs/Build.gitlab-ci.yml"

lint:
  image: koalaman/shellcheck-alpine:latest
  stage: test
  before_script:
  - apk update
  - apk add git
  script:
  - git ls-files --exclude='*.sh' --ignored -c -z | xargs -0r shellcheck

test:
  stage: test
  image:
    name: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA
    entrypoint: [""]
  services:
    - name: "docker:20.10-dind"
  variables:
    DOCKER_HOST: tcp://docker:2375
  parallel:
    matrix:
      - K3S_TAG: v1.20.15-k3s1
      - K3S_TAG: v1.21.10-k3s1
      - K3S_TAG: latest
  resource_group: agent
  before_script:
    - curl -s https://raw.githubusercontent.com/k3d-io/k3d/main/install.sh | bash
    - k3d version
    - k3d cluster create $CI_PIPELINE_ID --image rancher/k3s:$K3S_TAG
    - k3d kubeconfig get $CI_PIPELINE_ID > /var/run/kubeconfig
  script:
    - bash setup.sh -p $CI_PROJECT_ID -t $GITLAB_TOKEN -n ci
  after_script:
    - k3d cluster delete --all
    - bash teardown.sh
